/*
 *		    M_SCORE.C  MS Johnson  18-04-1993
 *
 *
 *			     Copyright (c) 1990
 *
 *		Copyright (c) 1990 KRAM Enterprises, USA
 *		Copyright (c) 1990 KRAMIT Limited, UK
 *		Copyright (c) 1990 KRAMSHIT, Slovenia
 *		Copyright (c) 1990 KRAMSKU, Finlandia
 *
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	reformating program
 *
 */

#include <math.h>
#include "malform.h"
#include "mat11.h"

extern char code[MAX_SQ1][MAX_CDE];
extern char seq2[MAX_SQ1][MAX_LN1];
extern int ren[MAX_SQ1];
extern float dist_id[MAX_SQ1][MAX_SQ1];

int nscore[MAX_SQ1][MAX_SQ1];
float nas[MAX_SQ1][MAX_SQ1];
float rscore[MAX_SQ1][MAX_SQ1];
float m_dist[MAX_SQ1][MAX_SQ1];

void m_score(ns,mat,pen,len,out,kitsch,pca)
int ns;
int pen,mat,len,out,kitsch,pca;
{
register int i,j,k;
int gaps;
int in_gap;

float tscore;

/* if m_flag==1, print alignment scores and normalized values */

/* calculate all paiwise alignment scores */

tscore=0.0;
for(i=0;i<ns-1;i++)
	{
	for(j=i+1;j<ns;j++)
		{
		gaps=0;
		in_gap=0;
		rscore[i][j]=0.0;
		for(k=0;k<len;k++)
			{
			if(seq2[i][k]=='-' && seq2[j][k]=='-');
			else if(seq2[i][k]=='-' || seq2[j][k]=='-')
				{
				if(in_gap==0);
				else	{
					if(gaps==0)rscore[i][j] -= (float)pen;
					if(gaps==0)gaps=1;
					}
				}
			else	{
				gaps=0;
				if(in_gap==0)in_gap=1;
				rscore[i][j] += (float)mats[mat][ind[seq2[i][k]-'A']][ind[seq2[j][k]-'A']];
				}
			}
		if(gaps==1)rscore[i][j] -= (float)pen; /* don't penal term gaps */
		rscore[j][i]=rscore[i][j];
		tscore+= rscore[i][j];
		}
	}

/* calculate average of max scores for each pair of sequences */

for(i=0;i<ns;i++)
	{
	rscore[i][i]=0.0;
	for(k=0;k<len;k++)
		{
		if(seq2[i][k]=='-');
		else rscore[i][i]+=
			(float)mats[mat][ind[seq2[i][k]-'A']][ind[seq2[i][k]-'A']];
		}
	}


/* print-out the scores */

if(out!=1)
	{
printf("\n\nRaw alignment scores / 100 \n");
printf("[Overall (sum of off-diagonal elements): %8.1f]:\n\n",tscore/100.0);
printf("            ");
for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n            ");
	printf(" [%3d]",i+1);
	}
printf("\n");
for(i=0;i<ns;i++)
	{
	printf("\n%3d-%-8.8s",i+1,code[i]);
	for(j=0;j<ns;j++)
		{
		if(j>0 && j%10==0)printf("\n            ");
		printf(" %5.1f",rscore[i][j]/100.0);
		}
	}
printf("\n");
	}

/* calculate normalized alignment score */

if(out!=1)
	{
printf("\n\nNormalized alignment scores (NAS = 100.0 * Sreal/Smax)\n\n");
printf("            ");
	}
if(out!=1)for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n            ");
	printf(" [%3d]",i+1);
	}
if(out!=1)printf("\n");
for(i=0;i<ns;i++)
	{
	if(out!=1)printf("\n%3d-%-8.8s",i+1,code[i]);
	for(j=0;j<ns;j++)
		{
		if(out!=1)if(j>0 && j%10==0)printf("\n            ");
		nas[i][j]= 100.0*rscore[i][j]/(0.5*(rscore[i][i]+rscore[j][j]));
		if(out!=1)printf(" %5.1f",nas[i][j]);
		}
	}
if(out!=1)printf("\n");


if(out!=1)
	{
printf("\n\nDistances based on NAS scores [-100.0 * ln(NAS/100.0)]:\n\n");
printf("            ");
	}

if(kitsch==1)printf("%d",ns);
else printf("%d %d",ns,ns); /* must be pca*/
if(pca==1)printf("\n          ");

if(out!=1)for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n            ");
	printf(" [%3d]",i+1);
	}
if(pca==1)for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n          ");
	printf("  %3d ",i+1);
	}
if(out!=1)printf("\n");
for(i=0;i<ns;i++)
	{
	if(out!=1)printf("\n%3d-%-8.8s",i+1,code[i]);
	else printf("\n%-10.10s",code[i]);
	for(j=0;j<ns;j++)
		{
		if(j>0 && j%10==0)
			{
			if(out!=1)printf("\n              ");
			else printf("\n          ");
			}
		if(nas[i][j]==0.0)
			{
			printf(" %6.1f", (-999.9));
			m_dist[i][j]=-999.9;
			}
		else	{
			printf(" %6.3f",fabs(-100.0 * log(nas[i][j]/100.0)));
			m_dist[i][j]=fabs(-100.0 * log(nas[i][j]/100.0));
			}
		}
	}
printf("\n");

if(out!=1)
	{
printf("\n\nDistances based on NAS ands IDs:\n\n");
printf("            ");
	}

if(kitsch==1)printf("%d",ns);
else printf("%d %d",ns,ns); /* must be pca*/
if(pca==1)printf("\n          ");

if(out!=1)for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n            ");
	printf(" [%3d]",i+1);
	}
if(pca==1)for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n          ");
	printf("  %3d ",i+1);
	}
if(out!=1)printf("\n");
for(i=0;i<ns;i++)
	{
	if(out!=1)printf("\n%3d-%-8.8s",i+1,code[i]);
	else printf("\n%-10.10s",code[i]);
	for(j=0;j<ns;j++)
		{
		if(j>0 && j%10==0)
			{
			if(out!=1)printf("\n              ");
			else printf("\n          ");
			}
			printf(" %6.3f", ((m_dist[i][j] + dist_id[i][j])/2.0));
		}
	}
printf("\n");
return;
}
