/*
 *		 MALHIGH.C  MS Johnson  26-06-1990
 *
 *
 *			     Copyright (c) 1990
 *
 *		Copyright (c) 1990 KRAM Enterprises, USA
 *		Copyright (c) 1990 KRAMIT Limited, UK
 *		Copyright (c) 1990 KRAMSHIT, Slovenia
 *		Copyright (c) 1990 KRAMSKU, Finlandia
 *
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	 highlight similarity over a segment
 *
 */

/*
 *	Modification history:

 *	1.0 -- original version. MSJ
 *	1.1 -- corrected for codes missing ">P1;". MSJ 9-8-90
 *	2.0 -- changed atoi usage per CONVEX; msj 5-3-91
 *	2.1 -- changes for SPROF and plain PIR files; msj 18-4-91
 *	2.2 -- changes to header info from malign and sprof; msj 29-6-91
 *	2.3 -- added percent identity calculations;  msj 4-7-91 
 *	2.4 -- added conservation plot to output; msj 6-3-92
 *	2.5 -- added scoring matrices; msj 19-4-93
 *	3.0 -- added -kit for kitsch input; -pca for principle comp file (PCA.LOCAL)
 *	4.0 --  name change to avoid conflicts with unix dos prog
 */

#include <stdio.h>
#include "malform.h"

#define SEG	7
#define MAX_AA 23

extern char seq2[MAX_SQ1][MAX_LN1];
extern int ind[MAX_IND];

int sum[MAX_SQ1];
int entropy[MAX_SQ1];
int twenty[23];

void malhigh(int ns, int len)
{
register i,j,k;

/*
 *	highlighting set
 */

for(k=0;k<len;k++)entropy[k]=0;
for(k=0;k<len;k++)
	{
	for(j=0;j<MAX_AA;j++)twenty[j]=0;
	for(j=0;j<ns;j++)
		{
/*
		if(seq2[j][k]=='-')twenty[MAX_AA-1]++;
*/
		if(seq2[j][k]=='-')entropy[k]++;
		else twenty[ind[seq2[j][k]-'A']]++;
		}

	/* number of different characters */

	for(j=0;j<MAX_AA;j++)if(twenty[j]>0)entropy[k]++;
	if(entropy[k]==1)entropy[k]=100;
	else entropy[k] = 100 - (int)(100.0 * (float)entropy[k]/(float)ns+0.5);
	}
for(k=0;k<len-(SEG-1);k++)
	{
	sum[k+2]=0;
	for(i=0;i<SEG;i++)
		{
		sum[k+2]+=entropy[k+i];
		}
	sum[k+2]= (int)((float)sum[k+2]/SEG)+0.5;
	if(k==0){
		sum[0]=sum[k+2];
		sum[1]=sum[k+2];
		}
	if(k==len-SEG)
		{
		sum[k+3]=sum[k+2];
		sum[k+4]=sum[k+2];
		}
	}
return;
}
