/*
 *		 MALPID.C  MS Johnson  26-06-1990
 *
 *
 *			     Copyright (c) 1990
 *
 *		Copyright (c) 1990 KRAM Enterprises, USA
 *		Copyright (c) 1990 KRAMIT Limited, UK
 *		Copyright (c) 1990 KRAMSHIT, Slovenia
 *		Copyright (c) 1990 KRAMSKU, Finlandia
 *
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	reformating program
 *
 */

/*
 *	Modification history:

 *	1.0 -- original version. MSJ
 *	1.1 -- corrected for codes missing ">P1;". MSJ 9-8-90
 *	2.0 -- changed atoi usage per CONVEX; msj 5-3-91
 *	2.1 -- changes for SPROF and plain PIR files; msj 18-4-91
 *	2.2 -- changes to header info from malign and sprof; msj 29-6-91
 *	2.3 -- added percent identity calculations;  msj 4-7-91 
 *	2.4 -- added conservation plot to output; msj 6-3-92
 *	2.5 -- added scoring matrices; msj 19-4-93
 *	3.0 -- added -kit for kitsch input; -pca for principle comp file (PCA.LOCAL)
 *	4.0 --  name change to avoid conflicts with unix dos prog
 */

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "malform.h"

#define DEF_WID	65			/* print width of alignment */
#define DEF_MAT	0			/* default matrix: birkbeck*/
#define DEF_PEN	40			/* default non-negative gap penalty */
#define SEG	7

extern char code[MAX_SQ1][MAX_CDE];
extern char seq2[MAX_SQ1][MAX_LN1];

float dist_id[MAX_SQ1][MAX_SQ1];
float fpid[MAX_SQ1][MAX_SQ1];

float mpidf_um();

void malpid(ns, len)
{
register i,j;

/*
 *	percentage identities
 */

for(i=0;i<ns;i++)
	{
	for(j=i;j<ns;j++)
		{
		fpid[i][j]=mpidf_um(i,j,len);
		fpid[j][i]=fpid[i][j];
		}
	}
	
printf("\n\nPercentage identities:\n\n");
printf("              ");
for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n              ");
	printf(" [%3d]",i+1);
	}
printf("\n");
for(i=0;i<ns;i++)
	{
	printf("\n%3d-%-10.10s",i+1,code[i]);
	for(j=0;j<ns;j++)
		{
		if(i==j)fpid[i][j]=100.0;
		if(j>0 && j%10==0)printf("\n              ");
		printf(" %5.3f",fpid[i][j]);
		}
	}
printf("\n");
	
printf("\n\nDistance from percentage identities:\n\n");
printf("              ");
for(i=0;i<ns;i++)
	{
	if(i>0 && i%10==0)printf("\n              ");
	printf(" [%3d]",i+1);
	}
printf("\n");
for(i=0;i<ns;i++)
	{
	printf("\n%3d-%-10.10s",i+1,code[i]);
	for(j=0;j<ns;j++)
		{
		if(j>0 && j%10==0)printf("\n              ");
		printf(" %5.3lf",fabs(-100.0 * log(fpid[i][j]/100.0)));
		dist_id[i][j]=fabs(-100.0 * log(fpid[i][j]/100.0));
		}
	}
printf("\n");
return;
}
