/*
 *		 MALPRINT.C  MS Johnson  26-06-1990
 *
 *
 *			     Copyright (c) 1990
 *
 *		Copyright (c) 1990 KRAM Enterprises, USA
 *		Copyright (c) 1990 KRAMIT Limited, UK
 *		Copyright (c) 1990 KRAMSHIT, Slovenia
 *		Copyright (c) 1990 KRAMSKU, Finlandia
 *
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	prints
 *
 */

/*
 *	Modification history:

 *	1.0 -- original version. MSJ
 *	1.1 -- corrected for codes missing ">P1;". MSJ 9-8-90
 *	2.0 -- changed atoi usage per CONVEX; msj 5-3-91
 *	2.1 -- changes for SPROF and plain PIR files; msj 18-4-91
 *	2.2 -- changes to header info from malign and sprof; msj 29-6-91
 *	2.3 -- added percent identity calculations;  msj 4-7-91 
 *	2.4 -- added conservation plot to output; msj 6-3-92
 *	2.5 -- added scoring matrices; msj 19-4-93
 *	3.0 -- added -kit for kitsch input; -pca for principle comp file (PCA.LOCAL)
 *	4.0 --  name change to avoid conflicts with unix dos prog
 */

#include <stdio.h>
#include "malform.h"

#define DEF_WID	65			/* print width of alignment */

extern char code[MAX_SQ1][MAX_CDE];
extern char title[MAX_SQ1][MAX_TIT];
extern char seq2[MAX_SQ1][MAX_LN1];
extern int sum[MAX_SQ1];

malprint(int c_flag, int ns, int len, int width)
{
register i,k;


int k_save;
int ctt;

/*
 *	now print it out
 */

printf("\n\n      Code       Title\n");
for(i=0;i<ns;i++) printf("\n[%3d] %-10.10s %s",i+1,code[i],title[i]);
printf("\n\n");

k_save=0;
for(;;){
	for(i=0;i<ns;i++)
		{
		printf("\n%-10.10s ",code[i]);
		for(k=k_save;k<k_save+width;k++)
			{
			if(k==len)putchar('*');
			if(k>=len)break;
			else putchar(seq2[i][k]);
			}
		}
	if(c_flag==1)
		{
		for(ctt=0;ctt<10;ctt++)
			{
			if(ctt==0)printf("\nC  100-91%% ");
			else if(ctt==1)printf("\nO P 90-81%% ");
			else if(ctt==2)printf("\nN O 80-71%% ");
			else if(ctt==3)printf("\nS S 70-61%% ");
			else if(ctt==4)printf("\nE I 60-51%% ");
			else if(ctt==5)printf("\nR T 50-41%% ");
			else if(ctt==6)printf("\nV I 40-31%% ");
			else if(ctt==7)printf("\nE O 30-21%% ");
			else if(ctt==8)printf("\nD N 20-11%% ");
			else if(ctt==9)printf("\n  S 10- 0%% ");
			for(k=k_save;k<k_save+width;k++)
				{
				if(k>=len)break;
				if(sum[k]<= 100-(ctt*10)
				&& sum[k]> 100-((ctt+1)*10))printf("*");
				else printf(" ");
				}
			}
		}

	printf("\n           ");
	for(k=k_save;k<k_save+width;k++)
		{
		if(k>=len)break;
		if(k>1 && (k+1)%10==0)printf("|");
		else printf("=");
		}
	printf("\n           ");
	for(k=k_save;k<k_save+width;k++)
		{
		if(k>=len)break;
		if(k>1 && (k+1)%10==0)
			{
			printf("%-4.4d ",k+1);
			k+= 4;
			}
		else printf(" ");
		if(k>(k_save+width))
			{
			k= k-(k-(k_save+width));
			k--;
			}
		if(k>=len)break;
		}
		
	k_save=k;
	printf("\n");
	if(k>=len)break;
	}
printf("\n");
return;
}
