/*
 *		 MALREAD.C  MS Johnson  26-06-1990
 *
 *
 *			     Copyright (c) 1990
 *
 *		Copyright (c) 1990 KRAM Enterprises, USA
 *		Copyright (c) 1990 KRAMIT Limited, UK
 *		Copyright (c) 1990 KRAMSHIT, Slovenia
 *		Copyright (c) 1990 KRAMSKU, Finlandia
 *
 *
 *	NOT TO BE COPIED OR SOLD UNDER ANY CIRCUMSTANCES WITHOUT THE
 *			  PERMISSION OF THE AUTHOR
 *
 *	multiple alignment program developed by the author at home
 *	and with his own resources.
 *
 *	reformating program
 *
 */

/*
 *	Modification history:

 *	1.0 -- original version. MSJ
 *	1.1 -- corrected for codes missing ">P1;". MSJ 9-8-90
 *	2.0 -- changed atoi usage per CONVEX; msj 5-3-91
 *	2.1 -- changes for SPROF and plain PIR files; msj 18-4-91
 *	2.2 -- changes to header info from malign and sprof; msj 29-6-91
 *	2.3 -- added percent identity calculations;  msj 4-7-91 
 *	2.4 -- added conservation plot to output; msj 6-3-92
 *	2.5 -- added scoring matrices; msj 19-4-93
 *	3.0 -- added -kit for kitsch input; -pca for principle comp file (PCA.LOCAL)
 *	4.0 --  name change to avoid conflicts with unix dos prog
 */

#include <stdio.h>
#include "malform.h"

char code[MAX_SQ1][MAX_CDE];
char seq2[MAX_SQ1][MAX_LN1];
char seqt[MAX_SQ1][MAX_LN1];
char title[MAX_SQ1][MAX_TIT];
int ren[MAX_SQ1];
int GG[MAX_SQ1];

void malread(int a_flag, int *ns, int *len)
{
register i,j,k,c;
int l;
int nns,llen;

char tcode[MAX_CDE];

j=0;
*len=0;
*ns=0;

for(;;)	{
	if((c=getchar())==EOF)break;
	else if(a_flag==0 && c=='^')break;
	else if(a_flag==1 && (c=='^' || c=='~'))break;
	else if(c=='\n');
	else ungetc(c,stdin);

	/* skip over comment lines liens beginning with C before first code line*/

	while((c=getchar())!=EOF)
		{
		if(c=='C' )while((c=getchar())!='\n');
		else	{
			ungetc(c,stdin);
			goto out;
			}
		}
	out:;

	ren[j]=0;

	/* grab code */

	k=0;
 	c=fscanf(stdin," %4s%s ",code[j],tcode);
	if(c==EOF)break;
	if(code[j][0]=='>')strcpy(code[j],tcode);
	else strcat(code[j],tcode);

	/* title */

	k=0;
	while((c=getchar())!='\n')title[j][k++]=c;
	title[j][k]='\0';
	
	k=0;
	while((c=getchar())!='*')
		{
		if(c=='\n');
		else if(c==' ');
		else
			{
			seqt[j][k++]= toupper(c);
			if(c=='-');
			else ren[j]++;
			}
		}
	if(*len != 0 && *len != k)
		{
		printf("\nSequences have different lengths (%d)!",j);
		printf("\nWarning: Truncation may occur!\n");
		}
	*len=k;
	j++;
	*ns=j;
	if(*ns>=MAX_SQ1-1)
		{
		printf("\nMore than %d sequences!",MAX_SQ1);
		printf("\nRecompile with larger MAX_SQ1 \n\n");
		}
	if(c=='*')getchar();
	if((c=getchar())==EOF)break;
	else ungetc(c,stdin);
	}

/* find common gaps */

nns=j;
llen=k;
for(j=0;j<llen;j++)GG[j]=0;
for(i=0;i<nns;i++)
	{
	for(j=0;j<llen;j++)
		{
		if(seqt[i][j]=='-')GG[j]++;
		}
	}

/* remove common gaps */

for(i=0;i<nns;i++)
	{
	k=0;
	for(j=0;j<llen;j++)
		{
		if(GG[j]==nns)l++;
		else	{
			seq2[i][k]=seqt[i][j];
			k++;
			}
		}
	}
*len=k;
/*
printf("\nk=%d cg=%d ",k,l/nns);
*/

return;
}
